import React, { Component } from "react";
import Router from "next/router";
import Link from "next/link";
import Select from "react-select";
import DetailSanksi from "@/components/Main/DetailSanksi";
import Header from "@/components/Main/Header";
import DetailPT from "@/components/Main/DetailPT";
import PermohonanPT from "@/components/Main/PermohonanPT";
import Riwayat from "@/components/PencabutanSanksi/Riwayat";
import { getSanksi } from "@/actions/sanksi";
import { addJawabanCabutSanksi } from "@/actions/cabutSanksi";
import ContentWrapper from "@/components/Layout/ContentWrapper";
import { Row, Col, Card, CardBody, FormGroup, Button, Input, Modal, ModalHeader, ModalBody, ModalFooter } from "reactstrap";
import { getPT } from "@/actions/PT";
import Loader from "@/components/Common/Loader";

let Dropzone = null;
class DropzoneWrapper extends Component {
	state = {
		isClient: false,
	};
	componentDidMount = () => {
		Dropzone = require("react-dropzone").default;
		this.setState({ isClient: true });
	};
	render() {
		return Dropzone ? <Dropzone {...this.props}>{this.props.children}</Dropzone> : null;
	}
}

const selectInstanceId = 1;

class JawabanPencabutanSanksi extends Component {
	constructor(props) {
		super(props);
		this.state = {
			selectedOption: null,
			files: [],
			keterangan: "",
			sanksi: {},
			pt: {},
		};
	}

	static getInitialProps = async ({ query }) => {
		return { query };
	};

	componentDidMount = async () => {
		const { query } = this.props;
		const sanksi = await getSanksi(query);
		const pt = await getPT({ id: query.ptId });
		this.setState({ pt, sanksi });
	};

	toggleModal = () => {
		this.setState({
			modal: !this.state.modal,
		});
	};

	handleChangeSelect = (selectedOption) => {
		this.setState({ selectedOption });
	};

	onDrop = (files) => {
		this.setState({
			files: files.map((file) =>
				Object.assign(file, {
					preview: URL.createObjectURL(file),
				})
			),
			stat: "Added " + files.length + " file(s)",
		});
	};

	uploadFiles = (e) => {
		e.preventDefault();
		e.stopPropagation();
		this.setState({
			stat: this.state.files.length ? "Dropzone ready to upload " + this.state.files.length + " file(s)" : "No files added.",
		});
	};

	clearFiles = (e) => {
		e.preventDefault();
		e.stopPropagation();
		this.setState({
			stat: this.state.files.length ? this.state.files.length + " file(s) cleared." : "No files to clear.",
		});
		this.setState({
			files: [],
		});
	};

	setKeterangan = (e) => {
		this.setState({ keterangan: e.target.value });
	};

	handleSimpan = async (e) => {
		e.preventDefault();
		const { selectedOption, keterangan } = this.state;
		const { noSanksi, ptId } = this.props.query;
		const formdata = new FormData();
		formdata.append("status", selectedOption.value);
		formdata.append("description", keterangan);
		if (this.state.files.length > 0) {
			this.state.files.forEach((e) => {
				formdata.append("files", e);
			});
			const added = await addJawabanCabutSanksi({ noSanksi, ptId }, formdata);
			// console.log(added);
			if (added) {
				Router.push({
					pathname: "/app/pencabutan-sanksi",
				});
			}
		}
	};

	render() {
		const { files, selectedOption, sanksi, pt } = this.state;

		const thumbs = files.map((file, index) => (
			<Col md={3} key={index}>
				<img className="img-fluid mb-2" src={file.preview} alt="Item" />
			</Col>
		));

		return (
			<ContentWrapper unwrap>
				{/* <Header /> */}
				<div className="p-3">
					<div className="content-heading">
						<div>Jawaban Permohonan Pencabutan Sanksi</div>
						<div className="ml-auto">
							<Link href="/app/pencabutan-sanksi">
								<button className="btn btn-sm btn-secondary text-sm">&lt; back</button>
							</Link>
						</div>
					</div>
					<Row>
						{sanksi.data ? (
							<Col xl="9">
								<Card className="card-default">
									<CardBody>
										<Row>
											<Col lg={12}>
												<DetailSanksi data={sanksi.data[0]} />
												<PermohonanPT data={sanksi.data[0].sanksi.cabut_sanksi} />
												<p className="lead bb">Jawaban</p>
												<form className="form-horizontal" method="get" action="/" onSubmit={this.onSubmit}>
													<FormGroup>
														<label className="row-form-label">Status:</label>
														<div className="row-md-10">
															<Select
																instanceId={selectInstanceId + 1}
																value={this.state.selectedOption}
																onChange={this.handleChangeSelect}
																options={[
																	{ value: "Diterima", label: "Diterima", className: "State-ACT" },
																	{ value: "Rekomendasi Perbaikan", label: "Rekomendasi Perbaikan", className: "State-ACT" },
																]}
																required
															/>
															{/* <span className="form-text">Pilih Jenis Pelanggaran</span> */}
														</div>
													</FormGroup>
													{selectedOption && selectedOption.value === "Rekomendasi Perbaikan" ? (
														<FormGroup>
															<label className="row-form-label">Keterangan:</label>
															<div className="row-md-10">
																<Input type="textarea" value={this.state.keterangan} onChange={this.setKeterangan} required />
																{/* <span className="form-text">Deskripsi pelaporan minimum karakter 50 maksimum 200 karakter</span> */}
															</div>
														</FormGroup>
													) : (
														""
													)}
													<FormGroup>
														<label className="row-form-label">Upload Dokumen:</label>
														<div className="row-md-10">
															<DropzoneWrapper className="" onDrop={this.onDrop}>
																{({ getRootProps, getInputProps, isDragActive }) => {
																	return (
																		<div {...getRootProps()} className={"dropzone card p-3 " + (isDragActive ? "dropzone-drag-active" : "")}>
																			<input {...getInputProps()} />
																			<div className="dropzone-previews flex">
																				{this.state.files.length > 0 ? <Row>{thumbs}</Row> : <div className="text-center dz-default dz-message">Drop files here to upload</div>}
																			</div>
																			<div className="d-flex align-items-center">
																				<small className="ml-auto">
																					<button type="button" className="btn btn-link" onClick={this.clearFiles}>
																						Clear files
																					</button>
																				</small>
																			</div>
																		</div>
																	);
																}}
															</DropzoneWrapper>
														</div>
													</FormGroup>
													<FormGroup>
														<div className="row-xl-10">
															<Button color="primary" onClick={sanksi.data && sanksi.data.length && sanksi.data[0].sanksi.cabut_sanksi.jawaban ? this.toggleModal : this.handleSimpan}>
																Simpan
															</Button>
														</div>
													</FormGroup>
												</form>
											</Col>
										</Row>
									</CardBody>
								</Card>
							</Col>
						) : (
							<Loader />
						)}
						<Col xl="3">{pt.data ? <DetailPT data={pt.data[0]} /> : <Loader />}</Col>
					</Row>
					{sanksi.data && (
						<Row>
							<Col>
								<Riwayat data={sanksi.data[0]} />
							</Col>
						</Row>
					)}
				</div>
				<Modal isOpen={this.state.modal} toggle={this.toggleModal}>
					<ModalBody>Apakah anda yakin ingin mengubah jawaban sebelumnya?</ModalBody>
					<ModalFooter>
						<Button color="primary" onClick={this.handleSimpan}>
							Ya
						</Button>{" "}
						<Button color="secondary" onClick={this.toggleModal}>
							Tidak
						</Button>
					</ModalFooter>
				</Modal>
			</ContentWrapper>
		);
	}
}

export default JawabanPencabutanSanksi;
